#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
//#include <fcntl.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/mman.h>
#include <asm/fcntl.h>
#include <linux/fb.h>
#include <sys/select.h>
#include <sys/time.h>

#include "bg.h"
#include "enemy.h"

#define FBDEVFILE "/dev/fb"
#define SEGADDR_1			0x10300000

#define LCD_WIDTH 640
#define LCD_HEIGHT 480
#define ENEMY_CNT 100

typedef unsigned char ubyte;

struct enemy_state
{
        int x,y;
        int life;
};
typedef struct enemy_state s_enemy;
s_enemy Enemy[ENEMY_CNT];
    
//
// only for 4 byte alignment
//
lmemcpy( char *dest, char *src, unsigned int count )
{
	unsigned long	*d, *s, *end;
	unsigned int	lcnt=count>>2;

	d = (unsigned long *)dest;
	s = (unsigned long *)src;
	end = s + lcnt;

	while( s < end )
		*d++ = *s++;
}

// number 7-segment change function
unsigned char Getsegcode(int x);
void print_7seg(int val);
void draw_image(int x, int y, int widht, int height, unsigned short *data);
void SetEnemy();
int Check_Hit(int x, int y);

///////////////////////////////////////////////////////////////////////////////////////////////////

// number 7-segment change function
unsigned char Getsegcode(int x)
{
	unsigned int code;
	switch(x)
	{
		case 0x0 : code = 0x3f;	break;
		case 0x1 : code = 0x06;	break;
		case 0x2 : code = 0x5b;	break;
		case 0x3 : code = 0x4f;	break;
		case 0x4 : code = 0x66;	break;
		case 0x5 : code = 0x6d;	break;
		case 0x6 : code = 0x7d;	break;
		case 0x7 : code = 0x07;	break;
		case 0x8 : code = 0x7f;	break;
		case 0x9 : code = 0x6f;	break;
		case 0xA : code = 0x77;	break;
		case 0xB : code = 0x7C;	break;
		case 0xC : code = 0x39;	break;
		case 0xD : code = 0x5e;	break;
		case 0xE : code = 0x79;	break;
		case 0xF : code = 0x71;	break;
		default  : code = 0;		break;
	}

	return code;
}

// number to 7-segment print (hex number)
int fd_led[2];
unsigned int *addr[2];

void print_7seg(int val)
{
	int i;
	
	unsigned char v[4];

	v[0] = Getsegcode(val & 0xF);
	v[1] = Getsegcode((val >> 4) & 0xF);
	v[2] = Getsegcode((val >> 8) & 0xF);
	v[3] = Getsegcode((val >> 12) & 0xF);
	
	*addr[1] = (v[3] << 8) | v[2] ;
	*addr[0] = (v[1] << 8) | v[0] ;
}
///////////////////////////////////////////////////////////////////////////////////////////////////

// make surface
unsigned short back_surface[LCD_WIDTH * LCD_HEIGHT];

void draw_image(int x, int y, int widht, int height, unsigned short *data)
{
	int n = 0;
	int i,j;

	for(j = y; j < height + y; ++j)
	{
		if(0 < y && y + height < LCD_HEIGHT)
		for(i = x; i< widht + x; ++i)
		{
			// draw image, but trancolor no draw
			if(0 < x && x + widht < LCD_WIDTH
			 && enemy_data[n] != 0xF81F)
			{
				*(back_surface + (j*LCD_WIDTH + i)) = *(data + n);
			}
			++n;
		}	
	}
}


// format enemty state
void SetEnemy()
{
	int i;
	for(i=0; i<ENEMY_CNT; ++i)
	{
		Enemy[i].life = 1;
		Enemy[i].x = (rand() % (640 - enemy_WIDTH));
		Enemy[i].y = -(i * 50);
	}
}

int Check_End()
{
	int i;
	int cnt = 0;
	int cnt2 = 0;
	
	for(i=0; i<ENEMY_CNT; ++i)
	{
		if(Enemy[i].life == 1)
			cnt++;
		if(Enemy[i].y > LCD_HEIGHT)
			cnt2++;
	}
	
	if(cnt && cnt2 < ENEMY_CNT)
		return 1;
	else
	{
		puts("Game End !!!");
		return 0;
	}
}

// Hit check, if is hit? return 0, else not hit? return -1;
int Check_Hit(int x, int y)
{
	int i;
	
	for(i=0; i<ENEMY_CNT; ++i)
	{
	
		if(Enemy[i].life == 0)
			continue;

		if(Enemy[i].x < x && x < (Enemy[i].x + enemy_WIDTH) &&
			Enemy[i].y < y && y < (Enemy[i].y + enemy_HEIGHT))
		{
			Enemy[i].life = 0;
			Enemy[i].x = 100000;
			Enemy[i].y = 100000;
			printf("hit it ! \nnum = %d  x = %d, y = %d\n", i, x, y);
			return 0;
		}
	}
	
	return -1;

}

int main()
{
	int fd_lcd;
	int cnt;
	int i;
	int add = 5;
	unsigned short *real_surface;
	
	// set touch system
	int fd_touch, judge;
	fd_set rfds;
	struct timeval tv;
	struct pkt_t
	 {
		short x, y, flag;
	};
	struct pkt_t p;

	if( (fd_touch=open("/dev/touch", O_RDWR))<0 )
	{
		puts("device open fail");
		exit( 2 );
	}
	puts("init toutch!!");
	 
	// set lcd system
	fd_lcd = open(FBDEVFILE, O_RDWR);
	if(fd_lcd < 0)
	{
		printf("Error fbdev open\n");
		exit(1);
	}
		
	// set lcd pointer
	real_surface =
	 (unsigned short *) mmap(0, LCD_WIDTH * LCD_HEIGHT * 2, PROT_READ | PROT_WRITE, MAP_SHARED, fd_lcd, 0);

	puts("init lcd");

	// set 7-sement pointer
	for(i = 0; i< 2; ++i)
	{
		if((fd_led[0]=open("/dev/mem", O_RDWR | O_SYNC)) < 0)
		{
			printf("memory open fail\n");
			exit(1);
		}
		addr[i] = mmap(NULL, 1, PROT_WRITE, MAP_SHARED, fd_led[0], SEGADDR_1 + (0x00100000 * i));
	}
	puts("init 7seg");
	cnt = 0;
       print_7seg(cnt);
   
       SetEnemy();
       
	while(Check_End())
	{
		tv.tv_sec = 0;
		tv.tv_usec = 10000;
		FD_ZERO( &rfds );
		FD_SET( fd_touch, &rfds );
		if( (judge = select(fd_touch+1, &rfds, NULL, NULL, &tv)) < 0 )
		{
			puts("select() fail");
			exit( 2 );
		}
		
		if( judge )
		{
			read( fd_touch, &p, 6 );
			if(p.flag == 0)
			{
				if(Check_Hit(p.x, p.y) == 0)
				{
					print_7seg(cnt++);
				}
			}
			
		//	printf("\n(x,y,flag,byte) = (%.3d,%.3d,%d,%d)", p.x, p.y, p.flag, judge);
		}
		// output backscreen
		lmemcpy(back_surface, bg_data, bg_WIDTH * bg_HEIGHT * 2);
			
		// output enemy screen
		for(i=0; i<ENEMY_CNT; ++i)
		{
			if(Enemy[i].life == 1)
			{
				draw_image(Enemy[i].x, Enemy[i].y, enemy_WIDTH, enemy_HEIGHT, enemy_data);
				Enemy[i].y+=add;
			}
		}
		add > 30 ? add : add++;
		
		// copy to real lcd
		lmemcpy(real_surface, back_surface, LCD_WIDTH * LCD_HEIGHT * 2);
						
	}
	if(cnt != 0)	
		cnt--;
	printf("Your score is dec = %d, hex(7_seg) = %x\n", cnt, cnt);
	
	// release lcd pointer
	munmap(real_surface, LCD_WIDTH * LCD_HEIGHT);
	close(fd_lcd);
	
	// release 7-segment pointer
	for(i = 0; i<2; ++i)
	{	
		munmap(addr[i], 1);
		close(fd_led[i]);
	};
	exit(0);
	
	return 0;
}
